PROGRAM Filef; { FileFormatter v1.1 }
{$I-}
{Written by Hunter Beanland. http://www.geocities.com/SiliconValley/Lab/1672/
 Please do not delete these lines!}

USES tools,Dos;
VAR
Line:STRING[200];
Opt,Fname,ofname,Words:STRING[50];
pc,e,i,h,Wo,linend:Integer;
loop,lin:longint;
fsp:searchrec;
Ch:Char;
Infile,Outfile:Text;
Quo,Lastw:Boolean;

CONST
numreswords=56;
reswords:ARRAY[1..numreswords] OF STRING[14]=('ABSOLUTE','AND','ASM','ARRAY',
'BEGIN','BREAK','CASE','CONST','CONSTRUCTOR',
'CONTINUE','DESTRUCTOR','DIV','DO','DOWNTO','ELSE','END','END;','END.',
'EXPORTS','FILE','FOR','FUNCTION','GOTO','IF','IMPLEMENTATION','IN',
'INHERITED','INLINE','INTERFACE','LABEL','LIBRARY','MOD','NIL','NOT','OBJECT',
'OF','OR','PACKED','PROCEDURE','PROGRAM','RECORD','REPEAT','SET','SHL','SHR',
'STRING','THEN','TO','TYPE','UNIT','UNTIL','USES','VAR','WHILE','WITH','XOR');
Title='FILE FORMATER  V 1.1  For Documents & Sorce Code   H.BEANLAND Copyright 93';

PROCEDURE Start;
BEGIN
  lin:=0;
  writeln(title);
  IF Pc<1 THEN BEGIN
    Writeln('SYNTAX: FileForm [Option] FileName.ext');
    Writeln('OPTIONS: Upper, Lower, Mixed, Tp');
    Halt;
  END;
  Fname:=Paramstr(2);
  Opt:=Paramstr(1);
  Assign(Infile,Fname);
  Reset(Infile);
  IF Ioresult <> 0 THEN BEGIN
    Write('ERROR: Can''t open file');
    Halt;
  END;
  upstr(opt);
END;

PROCEDURE Stop;                    { end processing }
BEGIN
  Close(Infile);
  Close(Outfile);
  writeln;
  Halt;
END;

PROCEDURE Caseit(Upper:Boolean);   { convert the case of line }
BEGIN
  IF Upper THEN upstr(line)
  else for i:=1 to length(line) do begin
    Wo:=Ord(line[i]);
    IF (Wo>64) AND (Wo<91) THEN BEGIN
     Wo:=Wo+32;
     line[i]:=Chr(Wo);
    END;
  end;
END;

PROCEDURE Mixed;          { make the first letter upper and rest lower }
BEGIN
  Lastw:=True;
  for i:=1 to length(line) do begin
    ch:=line[i];
    IF Lastw THEN BEGIN
      ch:=Upcase(ch);
      Lastw:=False;
    END ELSE
    BEGIN
      Wo:=Ord(ch);
      IF (Wo>64) AND (Wo<91) THEN BEGIN
       Wo:=Wo+32;
       ch:=Chr(Wo);
      end;
      Lastw:=False;
    END;
    IF ((ch<'A') or (ch>'Z')) AND ((ch<'a') or (ch>'z')) and
    ((ch<'') or (ch>'')) THEN Lastw:=True;
    line[i]:=ch;
  END;
END;

PROCEDURE Turbo;             { perform turbo pascal formating }
BEGIN
  Quo:=False;
  Lastw:=True;
  for i:=1 to length(line) do begin
    ch:=line[i];
    IF (Ch='''') or (ch='{') or (ch='}') THEN
     IF Quo THEN Quo:=False
     ELSE Quo:=True;
     IF Lastw AND (NOT Quo) THEN BEGIN
      Ch:=Upcase(Ch);
      Lastw:=False;
     END ELSE
     IF NOT Quo THEN BEGIN
       Wo:=Ord(ch);
       IF (Wo>64) AND (Wo<91) THEN BEGIN
        Wo:=Wo+32;
        ch:=Chr(Wo);
       end;
       Lastw:=False;
     END;
     IF ((ch<'A') or (ch>'Z')) AND ((ch<'a') or (ch>'z')) and
     ((ch<'') or (ch>'')) THEN Lastw:=True;
     line[i]:=ch;
  END;
  quo:=false;
  Words:='';
  wo:=1;
  E:=0;
  i:=1;
  repeat
   if line[i]=' ' then i:=i+1;
   i:=i+1;
  until line[i]<>' ';
  if odd(i) then insert(' ',line,1);
  repeat
   E:=E+1;
   IF (Line[E]='''') or (line[e]='{') THEN
    IF Quo THEN Quo:=False
    ELSE Quo:=True;
    IF ((ch>#63) or (ch<#91)) or ((ch>#96) or (ch<#123)) and
     ((ch>#127) or (ch<#169)) AND (NOT Quo) THEN begin
      Words:=Words+Line[E];
      if lastw then wo:=e
      else lastw:=false;
    end
    else begin
     upstr(words);
     for i:=1 to numreswords do
      if words=reswords[i] then
      for h:=1 to length(words) do
       line[wo+h]:=words[h];
      words:='';
      lastw:=true;
    end;
  UNTIL E=Length(Line);
END;

procedure processfile;  { read in lines and dish it out to the formatter }
begin
  lin:=0;
  write('       Lines Processed',#13);
  findfirst(fname,anyfile,fsp);
  repeat
   while not eoln(infile) do begin
    read(infile,ch);
    line:=line+ch;
    loop:=loop+1;
   end;
   IF Opt='UPPER' THEN Caseit(True);
   IF Opt='LOWER' THEN Caseit(False);
   IF Opt='MIXED' THEN Mixed;
   IF Opt='TP' THEN Turbo;
   write(outfile,line);
   lin:=lin+1;
   write(#13,lin);
   linend:=0;
   repeat
    read(infile,ch);
    loop:=loop+1;
    linend:=linend+1;
    if not odd(linend) then writeln(outfile);
   until (ch<>#13) and (ch<>#10);
   line:=ch;
  until fsp.size<=loop;
end;

BEGIN                                  { MAIN }
  pc:=Paramcount;
  Start;
  IF (Opt='UPPER') OR (Opt='LOWER') OR (Opt='MIXED') OR (Opt='TP') THEN BEGIN
    ofname:=fname;
{    fname:=copy(fname,1,pos('.',fname));
    fcopy(ofname,fname+'BAK');}
 ofname:='f';
    Assign(Outfile,ofname);
    Rewrite(Outfile);
    IF Ioresult<>0 THEN BEGIN
      Write('ERROR: Can''t write to file');
      Halt;
    END;
    Write('Please wait...  ');
    IF Opt='TP' THEN Writeln('Re-Formating to Pascal conventions')
    ELSE Writeln('Converting to ',Opt,' Case');
    processfile;
    Stop;
  END;
  pc:=0;
  Start;
END.




